from flask import Flask, render_template, request, session, g, Response, redirect, url_for
import random, io, csv

app = Flask(__name__)
gender = {}
annotator_gender = None
annotator_age = None

def read_data(f='../data/common1.csv'):
    data = []
    reader = csv.DictReader(open(f), delimiter=',')
    for row in reader:
        current = {'gender': row['gender'],
                   'comment': row['comment'],
                   'talkid': row['talkid'],
                   'videourl': row['videourl']}
        data.append(current)
    return data
data = read_data()

@app.route('/save_demographics', methods=["POST"])
def save_demographics():
    outd = request.form.to_dict()
    print(outd)
    global annotator_gender
    global annotator_age
    annotator_gender = outd['Gender']
    annotator_age = outd['Age']
    return redirect(url_for('task'))

csv_rows = []
@app.route('/')
def task():
    if annotator_gender is None:
        return render_template('intro.html')

    if len(data) == 0:
        return render_template('bias_turktask.html',
                               original_comment="DONE",
                               response_comment="DONE",
                               rows_so_far = len(csv_rows))

    sample = data[0]
    gender['gender'] = sample['gender']
    gender['talkid'] = sample['talkid']
    return render_template('bias_turktask.html',
                           original_comment=sample['videourl'],
                           response_comment=sample['comment'],
                           rows_so_far = len(csv_rows))

@app.route('/add_row', methods=["POST"])
def add_row():
    del data[0]
    outd = request.form.to_dict()
    outd['gender'] = gender['gender']
    outd['talkid'] = gender['talkid']
    outd['annotator_gender'] = annotator_gender
    outd['annotator_age'] = annotator_age
    csv_rows.append(outd)
    return redirect(url_for('task'))



@app.route('/write')
def write():
    if len(csv_rows) == 0:
        return 'no items'

    output = io.StringIO()
    writer = csv.DictWriter(output, fieldnames = csv_rows[0].keys())
    print(csv_rows[0].keys())
    writer.writeheader()
    for row in csv_rows:
        writer.writerow(row)

    return Response(
        output.getvalue(),
        mimetype="text/csv",
        headers={"Content-disposition":
                 "attachment; filename=myplot.csv"})


if __name__ == '__main__':
    app.run()
